Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/LinkDirectoryInputData.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/LinkDirectoryInputData.java	(revision 0)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/LinkDirectoryInputData.java	(revision 0)
@@ -0,0 +1,417 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.linkdirectory;
+
+import java.io.InputStream;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.avalon.framework.activity.Initializable;
+import org.apache.avalon.framework.configuration.Configuration;
+import org.apache.avalon.framework.configuration.DefaultConfigurationBuilder;
+import org.apache.avalon.framework.context.Context;
+import org.apache.avalon.framework.context.ContextException;
+import org.apache.avalon.framework.context.Contextualizable;
+import org.apache.avalon.framework.logger.AbstractLogEnabled;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.avalon.framework.service.Serviceable;
+import org.apache.cocoon.ProcessingException;
+import org.apache.cocoon.components.ContextHelper;
+import org.apache.cocoon.environment.Request;
+import org.apache.cocoon.xml.AttributesImpl;
+import org.apache.cocoon.xml.XMLUtils;
+import org.apache.commons.collections.MapUtils;
+import org.apache.commons.lang.StringUtils;
+import org.apache.excalibur.source.Source;
+import org.apache.excalibur.source.SourceResolver;
+import org.apache.tika.io.IOUtils;
+import org.xml.sax.ContentHandler;
+
+import org.ametys.plugins.linkdirectory.repository.DefaultLink;
+import org.ametys.web.WebConstants;
+import org.ametys.web.inputdata.InputData;
+import org.ametys.web.renderingcontext.RenderingContext;
+import org.ametys.web.renderingcontext.RenderingContextHandler;
+import org.ametys.web.repository.page.Page;
+import org.ametys.web.repository.site.Site;
+
+/**
+ * Input data for the link directory user preferences in thumbnails mode 
+ */
+public class LinkDirectoryInputData extends AbstractLogEnabled implements Contextualizable, InputData, Initializable, Serviceable
+{
+    /** The path to the configuration file */
+    private static final String __CONF_FILE_PATH = "skin://conf/link-themes.xml";
+    
+    /** The wildcard */
+    private static final String __WILDCARD = "*";
+    
+    /** The Avalon context */
+    private Context _context;
+    
+    /** The rendering context handler */
+    private RenderingContextHandler _renderingContextHandler;
+    
+    /** Excalibur source resolver */
+    private SourceResolver _sourceResolver;
+    
+    /** The configuration file */
+    private Map<String, Object> _configurationValues;
+
+    /** The last time the file was loaded */
+    private long _lastConfUpdate;
+
+    @Override
+    public void contextualize(Context context) throws ContextException
+    {
+        _context = context; 
+    }
+    
+    @Override
+    public void initialize() throws Exception
+    {
+        _lastConfUpdate = 0;
+    }
+    
+    @Override
+    public void service(ServiceManager manager) throws ServiceException
+    {
+        _renderingContextHandler = (RenderingContextHandler) manager.lookup(RenderingContextHandler.ROLE);
+        _sourceResolver = (SourceResolver) manager.lookup(SourceResolver.ROLE);
+    }
+    
+    @Override
+    public boolean isCacheable(Site site, Page currentPage)
+    {
+        Request request = ContextHelper.getRequest(_context);
+        
+        if (_renderingContextHandler.getRenderingContext() != RenderingContext.FRONT)
+        {
+            // We're in the back or in preview
+            return true;
+        }
+        
+        String template = _getTemplate(request);
+        if (template == null)
+        {
+            return true;
+        }
+        
+        try
+        {
+            _updateConfigurationValues();
+            if (MapUtils.isEmpty(_configurationValues) || _configurationValues.get("error") != null)
+            {
+                // No configuration file or there are errors
+                return true;
+            }
+            
+            Map<String, Boolean> configurableAndApplicableMap = _isConfigurableAndApplicable(template);
+            if (!configurableAndApplicableMap.get("applicable"))
+            {
+                // The current template is not configured for a link directory input data
+                return true;
+            }
+            
+            if (configurableAndApplicableMap.get("configurable"))
+            {
+                // The applications are configurable
+                return false;
+            }
+            
+            // Find the selected theme ids for this template 
+            List<String> themesIds = _getConfiguredThemesNames(template);
+            
+            return !DirectoryHelper.hasRestrictions(DirectoryHelper.getSiteName(request), DirectoryHelper.getLanguage(request), themesIds);
+        }
+        catch (Exception e)
+        {
+            getLogger().error("An error occurred while retrieving information from the skin configuration", e);
+            // Configuration file is not readable => toSAX method will not generate any xml
+            return true;
+        }
+    }
+
+    @Override
+    public void toSAX(ContentHandler contentHandler) throws ProcessingException
+    {
+        Request request = ContextHelper.getRequest(_context);
+        
+        // Get the current user's login if he is in the front office
+        String login = null;
+        if (_renderingContextHandler.getRenderingContext().equals(RenderingContext.FRONT))
+        {
+            login = (String) request.getAttribute(WebConstants.FO_LOGIN);
+        }
+        
+        String template = _getTemplate(request);
+        if (template == null)
+        {
+            return; 
+        }
+        
+        try
+        {
+            _updateConfigurationValues();
+            if (MapUtils.isEmpty(_configurationValues))
+            {
+                return;
+            }
+
+            contentHandler.startDocument();
+            AttributesImpl attrs = new AttributesImpl();
+            
+            // Is there an error in the configuration file ?
+            String error = (String) _configurationValues.get("error");
+            if (error != null)
+            {
+                attrs.addCDATAAttribute("error", error);
+                XMLUtils.createElement(contentHandler, "linkDirectory", attrs);
+                return;
+            }
+            
+            Map<String, Boolean> isConfigurableAndApplicableMap = _isConfigurableAndApplicable(_getTemplate(request));
+            attrs.addCDATAAttribute("applicable", isConfigurableAndApplicableMap.get("applicable") ? "true" : "false");
+            attrs.addCDATAAttribute("configurable", isConfigurableAndApplicableMap.get("configurable") ? "true" : "false");
+            
+            XMLUtils.startElement(contentHandler, "linkDirectory", attrs);
+            
+            XMLUtils.startElement(contentHandler, "links");
+            
+            _saxThemesLinks(contentHandler, login, request);
+            
+            XMLUtils.endElement(contentHandler, "links");
+            
+            XMLUtils.endElement(contentHandler, "linkDirectory");
+            
+            contentHandler.endDocument();
+        }
+        catch (Exception e)
+        {
+            getLogger().error("An exception occurred during the processing of the link directory's input data" , e);
+        }
+    }
+
+    private void _saxThemesLinks(ContentHandler contentHandler, String login, Request request) throws ProcessingException
+    {
+        String language = DirectoryHelper.getLanguage(request);
+        String siteName = DirectoryHelper.getSiteName(request);
+        try
+        {
+            List<String> configuredThemesNames = _getConfiguredThemesNames(_getTemplate(request));
+            
+            // Get themes ids with their names
+            Map<String, List<String>> themesMap = DirectoryHelper.getThemesMap(configuredThemesNames, siteName, language);
+            List<String> correctThemesIds = (List<String>) themesMap.get("correct-themes");
+            List<String> wrongThemesNames = (List<String>) themesMap.get("wrong-themes");
+            
+            if (correctThemesIds.isEmpty() && wrongThemesNames.isEmpty())
+            { 
+                // Sax all links
+                List<DefaultLink> links = DirectoryHelper.getLinks(new ArrayList<String>(), login, siteName, language);
+
+                DirectoryHelper.saxLinks(contentHandler, links, DirectoryHelper.getContextVars(request), siteName + "/" + language, login, true, true);
+            }
+            else
+            {
+                    
+                if (!wrongThemesNames.isEmpty())
+                {
+                    // Sax the names of the wrong themes
+                    XMLUtils.startElement(contentHandler, "wrong-themes");
+                    for (String wrongThemeName : wrongThemesNames)
+                    {
+                        XMLUtils.createElement(contentHandler, "wrong-theme", wrongThemeName);
+                    }
+                    XMLUtils.endElement(contentHandler, "wrong-themes");
+                }
+                
+                
+                if (correctThemesIds.isEmpty())
+                {
+                    getLogger().warn("All the themes ids are mispelled or the corresponding themes do not exist anymore.");
+                    return;
+                }
+                
+                // Get the links corresponding to the correct configured themes names
+                List<DefaultLink> links = DirectoryHelper.getLinks(correctThemesIds, login, siteName, language);
+                
+                // Sax the final set of links
+                DirectoryHelper.saxLinks(contentHandler, links, DirectoryHelper.getContextVars(request), siteName + "/" + language, login, true, true);
+            }
+        }
+        catch (Exception e)
+        {
+            throw new ProcessingException("An error occurred while retrieving or saxing the links", e);
+        }
+    }
+    
+    /**
+     * Retrieve the configured themes names defined in the skin file link-themes.xml for the current template
+     * @param template the current page's template
+     * @return the list of configured themes ids
+     */
+    private List<String> _getConfiguredThemesNames(String template)
+    {
+        List<Map<String, Object>> themesList = (List<Map<String, Object>>) _configurationValues.get("themes");
+        
+        for (Map<String, Object> themesMap : themesList)
+        {
+            List<String> templates = (List<String>) themesMap.get("templates");
+            if (templates.contains(template) || templates.contains(__WILDCARD))
+            {
+                // Get first matching template
+                return (List<String>) themesMap.get("theme-list");
+            }    
+        }
+        
+        return new ArrayList<String>();
+    }
+    
+    /**
+     * Retrieve the "configurable" attribute of a template of the configuration file
+     * @param template the current page's template
+     * @return true if the template is configurable, false otherwise
+     */
+    private Map<String, Boolean> _isConfigurableAndApplicable(String template) 
+    {
+        Map<String, Boolean> configurableAndApplicableMap = new HashMap<String, Boolean> ();
+        configurableAndApplicableMap.put("applicable", false);
+        configurableAndApplicableMap.put("configurable", false);
+        
+        List<Map<String, Object>> themesList = (List<Map<String, Object>>) _configurationValues.get("themes");
+        for (Map<String, Object> themesMap : themesList)
+        {
+            List<String> templates = (List<String>) themesMap.get("templates");
+            if (templates.contains(template) || templates.contains(__WILDCARD))
+            {
+                configurableAndApplicableMap.put("applicable", true);
+                configurableAndApplicableMap.put("configurable", (Boolean) themesMap.get("configurable"));
+                
+                break;
+            }
+        }
+        
+        return configurableAndApplicableMap;
+    }
+    
+    /**
+     * Update the configuration values : read them if the map is empty, update them if the file was changed or simply return them
+     * @throws Exception if an exception occurs
+     */
+    private void _updateConfigurationValues() throws Exception
+    {
+        Source source = null;
+        try
+        {
+            source = _sourceResolver.resolveURI(__CONF_FILE_PATH);
+            if (!source.exists())
+            {
+                getLogger().error("There is no configuration file at path '" + __CONF_FILE_PATH + "'.");
+            }
+            
+            long lastModified = source.getLastModified();
+            if (_lastConfUpdate != 0)
+            {
+                if (lastModified == _lastConfUpdate)
+                {
+                    return;
+                }
+            }
+            
+            _lastConfUpdate = lastModified;
+            _cacheConfigurationValues(source);
+        }
+        finally
+        {
+            if (_sourceResolver != null && source != null)
+            {
+                _sourceResolver.release(source);
+            }
+        }
+    }
+    
+    /**
+     * Read the configuration values and store them
+     * @param source the file's source
+     * @throws Exception if an exception occurs
+     */
+    private void _cacheConfigurationValues (Source source)
+    {
+        Map<String, Object> configurationValues = new HashMap<String, Object> ();
+        InputStream is = null;
+        
+        try 
+        {
+            is = source.getInputStream();
+            Configuration configuration = new DefaultConfigurationBuilder().build(source.getInputStream());
+            
+            Configuration[] themesConfigurations = configuration.getChildren("themes");
+            
+            List<Map<String, Object>> themesList = new ArrayList<Map<String, Object>> ();
+            for (Configuration themesConfiguration : themesConfigurations)
+            {
+                Map<String, Object> themesMap = new HashMap<String, Object> ();
+                List<String> themeList = new ArrayList<String> ();
+                
+                Configuration[] themeConfigurations = themesConfiguration.getChildren();
+                for (Configuration themeConfiguration : themeConfigurations)
+                {
+                    themeList.add(themeConfiguration.getAttribute("id", null));
+                }
+                
+                String templatesStr = themesConfiguration.getAttribute("templates", "*");
+                String[] templatesList = StringUtils.split(templatesStr, ',');
+                
+                themesMap.put("templates", Arrays.asList(templatesList));
+                themesMap.put("theme-list", themeList);
+                themesMap.put("configurable", themesConfiguration.getAttributeAsBoolean("configurable", false));
+                
+                themesList.add(themesMap);
+            }
+            
+            configurationValues.put("themes", themesList);
+            
+            _configurationValues = configurationValues;
+        }
+        catch (Exception e)
+        {
+            Map<String, Object> error = new HashMap<String, Object>();
+            getLogger().warn("An error occured while getting the configuration's file values", e);
+            error.put("error", e.getMessage());
+            
+            _configurationValues = error;
+        }
+        finally
+        {
+            IOUtils.closeQuietly(is);
+        }
+    }
+       
+    /**
+     * Get the current template 
+     * @param request the request
+     * @return the current template
+     */
+    private String _getTemplate(Request request)
+    {
+        return (String) request.getAttribute("template");
+    }
+}
Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/LinkDirectoryService.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/LinkDirectoryService.java	(revision 0)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/LinkDirectoryService.java	(revision 0)
@@ -0,0 +1,58 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.linkdirectory;
+
+import java.util.Arrays;
+
+import org.apache.commons.lang.StringUtils;
+
+import org.ametys.plugins.repository.metadata.CompositeMetadata;
+import org.ametys.web.repository.page.Page;
+import org.ametys.web.repository.page.ZoneItem;
+
+/**
+ *  Service for the link directory : not cacheable when dealing with links that have a limited access
+ */
+public class LinkDirectoryService extends org.ametys.web.service.StaticService
+{
+    @Override
+    public boolean isCacheable(Page currentPage, ZoneItem zoneItem)
+    {
+        CompositeMetadata serviceParameters = zoneItem.getServiceParameters();
+        boolean configurable = serviceParameters.getBoolean("configurable");
+        
+        if (configurable)
+        {
+            return false;
+        }
+        
+        if (currentPage != null)
+        {
+            // Get the selected themes ids from the service parameters
+            String themesIdsStr = serviceParameters.getString("themes");
+            String[] themesIds = StringUtils.split(themesIdsStr, ',');
+            
+            // Get the site name and the language from the page
+            String siteName = currentPage.getSiteName();
+            String language = currentPage.getSitemapName();
+            
+            return !DirectoryHelper.hasRestrictions(siteName, language, Arrays.asList(themesIds));
+        }
+
+        // Current page is null
+        return true;
+    }
+}
Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/LinkDirectorySetUserPreferencesAction.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/LinkDirectorySetUserPreferencesAction.java	(revision 0)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/LinkDirectorySetUserPreferencesAction.java	(revision 0)
@@ -0,0 +1,138 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.linkdirectory;
+
+import java.util.ArrayList;
+import java.util.Enumeration;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.avalon.framework.parameters.Parameters;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.acting.ServiceableAction;
+import org.apache.cocoon.environment.ObjectModelHelper;
+import org.apache.cocoon.environment.Redirector;
+import org.apache.cocoon.environment.Request;
+import org.apache.cocoon.environment.SourceResolver;
+import org.apache.commons.lang.StringUtils;
+
+import org.ametys.runtime.plugins.core.userpref.UserPreferencesManager;
+import org.ametys.runtime.util.cocoon.ActionResultGenerator;
+import org.ametys.web.WebConstants;
+import org.ametys.web.renderingcontext.RenderingContext;
+import org.ametys.web.renderingcontext.RenderingContextHandler;
+import org.ametys.web.userpref.FOUserPreferencesConstants;
+
+/**
+ * Create or set user preferences attached to a link directory service or the link directory input data mode for front-end users
+ */
+public class LinkDirectorySetUserPreferencesAction extends ServiceableAction
+{
+    /** The user preferences manager. */
+    private UserPreferencesManager _userPrefManager;
+
+    /** The rendering context handler */
+    private RenderingContextHandler _renderingContextHandler;
+    
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        super.service(serviceManager);
+        _userPrefManager = (UserPreferencesManager) serviceManager.lookup(UserPreferencesManager.ROLE + ".FO");
+        _renderingContextHandler = (RenderingContextHandler) serviceManager.lookup(RenderingContextHandler.ROLE);
+    }
+    
+    @Override
+    public Map act(Redirector redirector, SourceResolver resolver, Map objectModel, String source, Parameters parameters) throws Exception
+    {
+        Map<String, Object> result = new HashMap<String, Object>();
+        Request request = ObjectModelHelper.getRequest(objectModel);
+        
+        // We save user preferences for the front-end users only
+        if (_renderingContextHandler.getRenderingContext().equals(RenderingContext.FRONT))
+        {
+            String login = (String) request.getAttribute(WebConstants.FO_LOGIN);
+            if (StringUtils.isNotEmpty(login))
+            {
+                Map<String, String> values = new HashMap<String, String>();
+                
+                String siteName = DirectoryHelper.getSiteName(request);
+                String language = DirectoryHelper.getLanguage(request);
+                String zoneItemId = request.getParameter("zone-item-id");
+                
+                String storageContext = _getStorageContext(siteName, language, zoneItemId);
+                Map<String, String> contextVars = _getContextVars(siteName, language);
+                
+                values.put("checked-links", _getCheckedLinks(request));
+                
+                _userPrefManager.setUserPreferences(login, storageContext, contextVars, values);
+                
+                request.setAttribute(ActionResultGenerator.MAP_REQUEST_ATTR, result);
+            }
+        }
+        
+        return EMPTY_MAP;
+    }
+
+    /**
+     * Get the appropriate storage context 
+     * @param siteName the name of the site
+     * @param language the language
+     * @param zoneItemId the id of the zone item if we deal with a service, null for an input data
+     * @return the storage context in which the user preferences will be kept
+     */
+    private String _getStorageContext(String siteName, String language, String zoneItemId)
+    {
+        return StringUtils.isEmpty(zoneItemId) ? siteName + "/" + language : siteName + "/" + language + "/" + zoneItemId;
+    }
+    
+    /**
+     * Get the checked link ids from the request
+     * @param request the request
+     * @return the comma-separated string of checked links ids
+     */
+    private String _getCheckedLinks(Request request)
+    {
+        List<String> checkedLinksIds = new ArrayList<String> ();
+        Enumeration<String> parameterNames = request.getParameterNames();
+        while (parameterNames.hasMoreElements())
+        {
+            String parameterName = parameterNames.nextElement();
+            if (parameterName.startsWith("checkbox-"))
+            {
+                String isChecked = request.getParameter(parameterName);
+                if (isChecked.equals("true"))
+                {
+                    checkedLinksIds.add(parameterName.substring(9));
+                }
+            }
+        }
+        
+        return StringUtils.join(checkedLinksIds, ',');
+    }
+    
+    private Map<String, String> _getContextVars(String siteName, String language)
+    {
+        Map<String, String> contextVars = new HashMap<String, String>();
+        
+        contextVars.put(FOUserPreferencesConstants.CONTEXT_VAR_SITENAME, siteName);
+        contextVars.put(FOUserPreferencesConstants.CONTEXT_VAR_LANGUAGE, language);
+        
+        return contextVars;
+    }
+}
Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/CreateLinkAction.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/CreateLinkAction.java	(revision 28682)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/CreateLinkAction.java	(working copy)
@@ -95,6 +95,12 @@
         String pictureType = (String) jsParameters.get("picture#type");
         String pictureAlternative = StringUtils.defaultString((String) jsParameters.get("picture-alternative"));
         String themesStr = (String) jsParameters.get("themes");
+        boolean grantAnyUser = (Boolean) jsParameters.get("grant-any-user");
+        String foUsers = (String) jsParameters.get("fousers");
+        String foGroups = (String) jsParameters.get("fogroups");
+
+        String[] grantedUsers = StringUtils.split(foUsers, ',');
+        String[] grantedGroups = StringUtils.split(foGroups, ',');
         
         // Check that the word doesn't already exist.
         if (urlExists(url, siteName, language))
@@ -113,7 +119,7 @@
         link.setAlternative(alternative);
         link.setPictureAlternative(pictureAlternative);
         link.setThemes(StringUtils.split(themesStr, ','));
-        
+
         if (StringUtils.isEmpty(pictureId))
         {
             // Deletion.
@@ -135,6 +141,10 @@
             link.setExternalPicture(finalMimeType, filename, upload.getInputStream());
         }
         
+        link.setGrantAnyUser(grantAnyUser);
+        link.setGrantedUsers(grantedUsers);
+        link.setGrantedGroups(grantedGroups);
+        
         rootNode.saveChanges();
         
         result.put("id", link.getId());
